"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const template_processor_1 = require("template-processor");
const DocumentFragment_class_1 = require("./DocumentFragment.class");
const HTMLElement_class_1 = require("./HTMLElement.class");
class xjs_HTMLTemplateElement extends HTMLElement_class_1.default {
    static async fromFile(filepath) {
        let elem = (await DocumentFragment_class_1.default.fromFile(filepath)).node.querySelector('template');
        if (elem === null) {
            throw new ReferenceError(`No \`template\` element was found in file: ${filepath}`);
        }
        return new xjs_HTMLTemplateElement(elem);
    }
    static fromFileSync(filepath) {
        let elem = DocumentFragment_class_1.default.fromFileSync(filepath).node.querySelector('template');
        if (elem === null) {
            throw new ReferenceError(`No \`template\` element was found in file: ${filepath}`);
        }
        return new xjs_HTMLTemplateElement(elem);
    }
    constructor(node) {
        super(node);
    }
    get node() { return super.node; }
    content() {
        return this.node.content;
    }
    render(renderer, data, options = {}, this_arg = this) {
        return new template_processor_1.Processor(this.node, renderer).process(data, options, this_arg);
    }
}
exports.default = xjs_HTMLTemplateElement;
